﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace GIT
{
    public partial class FormDepartments : Form
    {

        int List_index;

        public FormDepartments()
        {
            InitializeComponent();
        }


      

        private void button1_Click(object sender, EventArgs e)
        {
       

            
            //Check the User Input
            if (textBox_Id.Text.Trim() == "")
            {
               
                erp1.SetError(textBox_Id, "لطفا شماره بخش را  وارد نمایید !");
         
                textBox_Id.Focus();
                return;

            }
            else  if (textBox_Name.Text.Trim() == "")
                {
                    erp1.SetError(textBox_Name, "لطفا نام بخش را  وارد نمایید !");
                    textBox_Name.Focus();
                    return;
                }
                else if (txt_maxpersonwork.Text.Trim() == "")
                    {
                        erp1.SetError(txt_maxpersonwork, "لطفا حداکثر تعداد اعضای بخش را  وارد نمایید !");
                        txt_maxpersonwork.Focus();
                        return;

                    }
                    else  if (txttel.Text.Trim() == "")
                        {

                            erp1.SetError(txttel, "لطفاتلفن  بخش را  وارد نمایید !");
                            txttel.Focus();
                            return;

                        }
            else  if (txt_addrress.Text.Trim() == "")
                            {
                                erp1.SetError(txt_addrress, "لطفا آدرس بخش را  وارد نمایید !");
                                txt_addrress.Focus();
                                return;

                            }

            if (check_Id(textBox_Id.Text) == true)
            {
                erp1.Clear();
                erp1.SetError(textBox_Id, "شماره بخش  تکراری می باشد");

                textBox_Id.Focus();
                return;

            }

            // Department is Created and Added to myData
            Department D = new Department(textBox_Id.Text, textBox_Name.Text,txt_maxpersonwork.Text, txttel.Text, txt_addrress.Text);
            myData.departments.Add(D);
            //Updating the Department List to listView_Departments
            ListViewItem item = new ListViewItem(D.id);
            item.SubItems.Add(D.name);
            item.SubItems.Add(D.tel);
            item.SubItems.Add(D.address);
            item.SubItems.Add(D.maxperson.ToString ());
            listView_Departments.Items.Add(item);
            

            Clear_form();


        }
        public bool check_Id(string id)
        {

            for (int i = 0; i < listView_Departments.Items.Count; i++)
            {
                if (listView_Departments.Items[i].SubItems[0].Text == id)
                {
                    return true;
                }
            }
            return false; 
        }
        public void Clear_form()
        {
            textBox_Id.Text = "";
            textBox_Name.Text = "";
            txttel .Text="";
            txt_addrress .Text="";
            txt_maxpersonwork.Text = "";
        }

        private void FormDepartments_Load(object sender, EventArgs e)
        {
            List_index = -1;
            Fill_List();
            //نمايش کليه بخش ها در لحظه لود شدن فرم
        }


        void Fill_List()
        {
            listView_Departments.Items.Clear();
            foreach (Department department in myData.departments)
            {
                ListViewItem item = new ListViewItem();
                item.Tag = department;
                item.Text = department.id;
                item.SubItems.Add(department.name);
                item.SubItems.Add(department.tel);
                item.SubItems.Add(department.address);
                item.SubItems.Add(department.maxperson.ToString ());

                listView_Departments.Items.Add(item);
            }

        }

        
        private void Disable_from()
        {
            textBox_Id.Enabled = false;
            textBox_Name.Enabled = false;
            txttel.Enabled = false;
            txt_maxpersonwork.Enabled = false;
            txt_addrress.Enabled = false;
        }
        private void Enable_Form()
        {
            textBox_Id.Enabled = true;
            textBox_Name.Enabled = true; ;
            txttel.Enabled = true;
            txt_maxpersonwork.Enabled = true;
            txt_addrress.Enabled = true;
        }
        public void ClearerrProviding()
        {
            erp1.Clear();
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }

        private void textBox_Id_TextChanged(object sender, EventArgs e)
        {
            ClearerrProviding();
        }

        private void textBox_Name_TextChanged(object sender, EventArgs e)
        {
            ClearerrProviding();
        }

        private void txt_maxpersonwork_TextChanged(object sender, EventArgs e)
        {
            ClearerrProviding();
        }

        private void txttel_TextChanged(object sender, EventArgs e)
        {
            ClearerrProviding();
        }

        private void txt_addrress_TextChanged(object sender, EventArgs e)
        {
            ClearerrProviding();
        }

        private void tolsdelete_Click(object sender, EventArgs e)
        {

        }

        private void btn_deletedepartment_Click(object sender, EventArgs e)
        {
            if (listView_Departments.Items.Count == 0)
            {
                MessageBox.Show("هیچ رکوردی برای حذف کردن وجود ندارد");
                return;
            }
            if (List_index != -1)
            {
                myData.departments.RemoveAt(List_index);
                Fill_List();
                Clear_form();
                List_index = -1;
            }
            else
            {
                MessageBox.Show("هیچ رکوردی برای حذف انتخاب نشده است!","اخطار");
                List_index = -1;
            }
            //while (listView_Departments.SelectedItems.Count > 0)
            //{


            //    listView_Departments.Items.Remove(listView_Departments.SelectedItems[0]);



            //}


        }


        private void btn_chnagedepartment_Click(object sender, EventArgs e)
        {
           
            if(List_index ==-1) 
            {
                MessageBox.Show("هسچ رکوردی برای تغییر انتخاب نشده است");
                return;
            }
            if (textBox_Id.Text.Trim() == "")
            {

                erp1.SetError(textBox_Id, "لطفا شماره بخش را  وارد نمایید !");

                textBox_Id.Focus();
                return;

            }
            else if (textBox_Name.Text.Trim() == "")
            {
                erp1.SetError(textBox_Name, "لطفا نام بخش را  وارد نمایید !");
                textBox_Name.Focus();
                return;
            }
            else if (txt_maxpersonwork.Text.Trim() == "")
            {
                erp1.SetError(txt_maxpersonwork, "لطفا حداکثر تعداد اعضای بخش را  وارد نمایید !");
                txt_maxpersonwork.Focus();
                return;

            }
            else if (txttel.Text.Trim() == "")
            {

                erp1.SetError(txttel, "لطفاتلفن  بخش را  وارد نمایید !");
                txttel.Focus();
                return;

            }
            else if (txt_addrress.Text.Trim() == "")
            {
                erp1.SetError(txt_addrress, "لطفا آدرس بخش را  وارد نمایید !");
                txt_addrress.Focus();
                return;

            }

           // if (check_Id(textBox_Id.Text) == true)
           //{
           //    erp1.Clear();
           //   erp1.SetError(textBox_Id, "شماره بخش  تکراری می باشد");

           //    textBox_Id.Focus();
           //     return;

           // }
            myData.departments[List_index].id = textBox_Id.Text;
            myData.departments[List_index].name = textBox_Name.Text;
            myData.departments[List_index].tel = txttel.Text;
            myData.departments[List_index].address= txt_addrress.Text;
            myData.departments[List_index].maxperson  =int.Parse (txt_maxpersonwork.Text);
            List_index = -1;
            Clear_form();
            Fill_List();
            
            
           
        }

        private void button1_Click_1(object sender, EventArgs e)
        {

   
            
        }

        private void listView_Departments_SelectedIndexChanged(object sender, EventArgs e)
        {
            ListView.SelectedIndexCollection indexes = listView_Departments.SelectedIndices;
            foreach (int index1 in indexes)
            {
                List_index = index1;
            }
        }

        private void listView_Departments_DoubleClick(object sender, EventArgs e)
        {
            
        }

        private void listView_Departments_Click(object sender, EventArgs e)
        {
            textBox_Id.Text = myData.departments[List_index].id;
            textBox_Name.Text = myData.departments[List_index].name;
            txt_maxpersonwork.Text = myData.departments[List_index].maxperson.ToString ();
            txttel.Text = myData.departments[List_index].tel;
            txt_addrress.Text = myData.departments[List_index].address;
            
        }

        private void txt_maxpersonwork_KeyPress(object sender, KeyPressEventArgs e)
        {

        }

    


    }
}