﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace GIT 
    

{
    public partial class Frm_AddPersonelWorkTime : Form
    {
        private int lst_index;
        private bool nonNumberEntered = false;
        public Frm_AddPersonelWorkTime()
        {
            InitializeComponent();
        }

        private void Frm_AddPersonelWorkTime_Load(object sender, EventArgs e)
        {
            lst_index = -1;
            fill_data();
        }

        private void fill_data()
        {
           listView1.Items.Clear();
            foreach (Personnel   personel in  myData.personnels)
            {
                if(personel .TypeOfpersonell ==false )
                {
                    ListViewItem item = new ListViewItem(personel.Id);
                    item.SubItems.Add(personel.Name);
                    item.SubItems.Add(personel.Family);
                    item.SubItems.Add(personel.MaxDateWorkInMonth.ToString());
                  //  item.SubItems.Add(Salary.ToString());
                   
                   //   item.SubItems.Add(personel .Ezafekari.ToString());
                    item.SubItems.Add(personel.Adres);
                    item.SubItems.Add(personel.Item_inList1.ToString());
                    listView1.Items.Add(item);
                    
                }
    

            }
            
        }

        private void txt_personelWorkTime_TextChanged(object sender, EventArgs e)
        {
            Clearerp1();
        }
   
        private void txt_personelWorkTime_KeyDown(object sender, KeyEventArgs e)
        {
            nonNumberEntered = false;
            if (e.KeyCode < Keys.D0 || e.KeyCode > Keys.D9)
            {
                // Determine whether the keystroke is a number from the keypad.
                if (e.KeyCode < Keys.NumPad0 || e.KeyCode > Keys.NumPad9)
                {
                    // Determine whether the keystroke is a backspace.
                    if (e.KeyCode != Keys.Back)
                    {
                        // A non-numerical keystroke was pressed.
                        // Set the flag to true and evaluate in KeyPress event.
                        nonNumberEntered = true;
                    }
                }
            }

        }

        private void txt_personelWorkTime_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (nonNumberEntered == true)
            {
                // Stop the character from being entered into the control since it is non-numerical.
                e.Handled = true;
            }

        }

        private void txt_maxtimeInmonth_KeyDown(object sender, KeyEventArgs e)
        {
            nonNumberEntered = false;
            if (e.KeyCode < Keys.D0 || e.KeyCode > Keys.D9)
            {
                // Determine whether the keystroke is a number from the keypad.
                if (e.KeyCode < Keys.NumPad0 || e.KeyCode > Keys.NumPad9)
                {
                    // Determine whether the keystroke is a backspace.
                    if (e.KeyCode != Keys.Back)
                    {
                        // A non-numerical keystroke was pressed.
                        // Set the flag to true and evaluate in KeyPress event.
                        nonNumberEntered = true;
                    }
                }
            }
        }

        private void txt_salary_KeyDown(object sender, KeyEventArgs e)
        {
            nonNumberEntered = false;
            if (e.KeyCode < Keys.D0 || e.KeyCode > Keys.D9)
            {
                // Determine whether the keystroke is a number from the keypad.
                if (e.KeyCode < Keys.NumPad0 || e.KeyCode > Keys.NumPad9)
                {
                    // Determine whether the keystroke is a backspace.
                    if (e.KeyCode != Keys.Back)
                    {
                        // A non-numerical keystroke was pressed.
                        // Set the flag to true and evaluate in KeyPress event.
                        nonNumberEntered = true;
                    }
                }
            }
        }

        private void txt_EzafeKari_KeyDown(object sender, KeyEventArgs e)
        {
            nonNumberEntered = false;
            if (e.KeyCode < Keys.D0 || e.KeyCode > Keys.D9)
            {
                // Determine whether the keystroke is a number from the keypad.
                if (e.KeyCode < Keys.NumPad0 || e.KeyCode > Keys.NumPad9)
                {
                    // Determine whether the keystroke is a backspace.
                    if (e.KeyCode != Keys.Back)
                    {
                        // A non-numerical keystroke was pressed.
                        // Set the flag to true and evaluate in KeyPress event.
                        nonNumberEntered = true;
                    }
                }
            }
        }

        private void txt_maxtimeInmonth_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (nonNumberEntered == true)
            {
                // Stop the character from being entered into the control since it is non-numerical.
                e.Handled = true;
            }
        }

        private void txt_salary_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (nonNumberEntered == true)
            {
                // Stop the character from being entered into the control since it is non-numerical.
                e.Handled = true;
            }
        }

        private void txt_EzafeKari_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (nonNumberEntered == true)
            {
                // Stop the character from being entered into the control since it is non-numerical.
                e.Handled = true;
            }
        }
        private void Clearerp1()
        {
            erp1.Clear();

        }
        public bool CheckIdIsExist(string i)
        {
            int id = int.Parse(i);
            foreach (Personnel p in myData.personnels)
            {
                int pid = int.Parse(p.Id);
                if (pid == id)
                {
                    return false ;
                }
            }
            return true ;
        }

        private void btn_add_Click(object sender, EventArgs e)
        {
            if(CheckForm( txt_personelId .Text,txt_personelNameWorkTime .Text ,txt_personelFamilyWorkTime .Text ,txt_maxtimeInmonth .Text ,txt_salary .Text ,txt_EzafeKari .Text ,txt_addressWorkTime .Text )==true )
            {
                PersonnelWorkTime p = new PersonnelWorkTime(txt_personelId.Text, txt_personelNameWorkTime.Text,
                                                            txt_personelFamilyWorkTime.Text, txt_maxtimeInmonth.Text,
                                                            txt_salary.Text, txt_EzafeKari.Text,
                                                            txt_addressWorkTime.Text);
                myData.personnels.Add(p);
                p.SetItemInlist();
                MessageBox.Show(p.Item_inList1.ToString());
                ListViewItem item = new ListViewItem(p.Id);
                item.SubItems.Add(p.Name);
                item.SubItems.Add(p.Family);
                item.SubItems.Add(p.MaxDateWorkInMonth .ToString( ));
                item.SubItems.Add(p.Salary .ToString( ));
                item.SubItems.Add(p.Ezafekari.ToString());
                item.SubItems.Add(p.Adres);
                item.SubItems.Add(p.Item_inList1.ToString());
                listView1.Items.Add(item);


                clear_form();

                
            }

        }
        private void clear_form()
        {
            txt_personelId.Text = "";
            txt_personelNameWorkTime.Text = "";
            txt_personelFamilyWorkTime.Text = "";
            txt_maxtimeInmonth.Text = "";
            txt_salary.Text = "";
            txt_EzafeKari.Text = "";
            txt_addressWorkTime.Text = "";

        }
            private bool CheckForm(string i,string n,string f,string max,string salary,string ezafekari,string adres)
        {

            if(i=="")
            {
                erp1.SetError(txt_personelId, "شماره پرسنل را وارد نمایید");
                txt_personelId.Focus();
                return false;
                    
            }
            else if(n=="")
            {
                erp1.SetError(txt_personelNameWorkTime, "نام پرسنل را وارد نماید");
                txt_personelNameWorkTime.Focus();
                return false;

            }
            else if(f=="")
            {
                erp1.SetError(txt_personelFamilyWorkTime, "نام خانوتدگی را وارد نمایید");
                txt_personelFamilyWorkTime.Focus();
                return false;

            }
            else if(max=="")
            {
                erp1.SetError(txt_maxtimeInmonth, "حداکثر ساعات کار در ماه را وارد نمایید");
                txt_maxtimeInmonth.Focus();
                return false;


            }
            else if(salary =="")
            {
                erp1.SetError(txt_salary, "مبلغ حقوق به ازاء هر ساعت را وارد نمایید");
                txt_salary.Focus();
                return false;

            }
            else if(ezafekari=="")
            {

                erp1.SetError(txt_EzafeKari, "مبلغ اضافه کاری به ازای هر ساعت را وارد نمایید");
                txt_EzafeKari.Focus();
                return false;

            }
            else if(adres =="")
            {
                erp1.SetError(txt_addressWorkTime, "آدرس را وارد نمایید");
                txt_addressWorkTime.Focus();
                return false;
            }
            else if(CheckIdIsExist( i)==false )
            {
                erp1.SetError(txt_personelId, "این شماره پرسنل قبلا وارد شده است");
                txt_personelId.Focus();
                return false;
            }
            else
            {
                return true;
            }
        }

            private void txt_personelNameWorkTime_TextChanged(object sender, EventArgs e)
            {
                Clearerp1();
            }

            private void txt_personelFamilyWorkTime_TextChanged(object sender, EventArgs e)
            {
                Clearerp1();
            }

            private void txt_addressWorkTime_TextChanged(object sender, EventArgs e)
            {
                Clearerp1();
            }

            private void txt_maxtimeInmonth_TextChanged(object sender, EventArgs e)
            {
                Clearerp1();
            }

            private void txt_salary_TextChanged(object sender, EventArgs e)
            {
                Clearerp1();
            }

            private void txt_EzafeKari_TextChanged(object sender, EventArgs e)
            {
                Clearerp1();
            }

            private void listView1_SelectedIndexChanged(object sender, EventArgs e)
            {
                ListView.SelectedListViewItemCollection lst =listView1 .SelectedItems;
                foreach (ListViewItem item in lst)
                {
                    lst_index = int.Parse(item.SubItems[7].Text);


                }
                
            }


    }
}
